Index: /palm/trunk/SOURCE/nesting_offl_mod.f90
===================================================================
--- /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4723)
+++ /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4724)
@@ -488,346 +533,592 @@
 !--    For the v-component, the data starts at nysv, while for the other
 !--    quantities the data starts at nys. This is equivalent at the north
-!--    and south domain boundary for the u-component. 
+!--    and south domain boundary for the u-component (nxlu).
 !--    Note, lateral data is also accessed by parallel IO, which is the reason
 !--    why different arguments are passed depending on the boundary control
-!--    flags. Cores that do not belong to the respective boundary just make
+!--    flags. Cores that do not belong to the respective boundary only do
 !--    a dummy read with count = 0, just in order to participate the collective
-!--    operation. 
-!--    Read data for western boundary    
-       CALL get_variable( pids_id, 'ls_forcing_left_u',                        &
-                          nest_offl%u_left,                                    & ! array to be read
-                          MERGE( nys+1, 1, bc_dirichlet_l),                    & ! start index y direction
-                          MERGE( nzb+1, 1, bc_dirichlet_l),                    & ! start index z direction
-                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),         & ! start index time dimension
-                          MERGE( nyn-nys+1, 0, bc_dirichlet_l),                & ! number of elements along y
-                          MERGE( nest_offl%nzu, 0, bc_dirichlet_l),            & ! number of elements alogn z
-                          MERGE( 2, 0, bc_dirichlet_l),                        & ! number of time steps (2 or 0)
-                          .TRUE. )                                               ! parallel IO when compiled accordingly
-      
-       CALL get_variable( pids_id, 'ls_forcing_left_v',                        &
-                          nest_offl%v_left,                                    &
-                          MERGE( nysv, 1, bc_dirichlet_l),                     &
-                          MERGE( nzb+1, 1, bc_dirichlet_l),                    &
-                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),         &
-                          MERGE( nyn-nysv+1, 0, bc_dirichlet_l),               &
-                          MERGE( nest_offl%nzu, 0, bc_dirichlet_l),            &
-                          MERGE( 2, 0, bc_dirichlet_l),                        &
-                          .TRUE. )                                        
-
-       CALL get_variable( pids_id, 'ls_forcing_left_w',                        &
-                          nest_offl%w_left,                                    &
-                          MERGE( nys+1, 1, bc_dirichlet_l),                    &
-                          MERGE( nzb+1, 1, bc_dirichlet_l),                    &
-                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),         &
-                          MERGE( nyn-nys+1, 0, bc_dirichlet_l),                &
-                          MERGE( nest_offl%nzw, 0, bc_dirichlet_l),            &
-                          MERGE( 2, 0, bc_dirichlet_l),                        &
-                          .TRUE. )   
-
-       IF ( .NOT. neutral )  THEN
-          CALL get_variable( pids_id, 'ls_forcing_left_pt',                    &
-                             nest_offl%pt_left,                                &
-                             MERGE( nys+1, 1, bc_dirichlet_l),                 &
-                             MERGE( nzb+1, 1, bc_dirichlet_l),                 &
-                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),      &
-                             MERGE( nyn-nys+1, 0, bc_dirichlet_l),             &
-                             MERGE( nest_offl%nzu, 0, bc_dirichlet_l),         &
-                             MERGE( 2, 0, bc_dirichlet_l),                     &
+!--    operation. This is because collective parallel access shows better
+!--    performance than just a conditional access.
+!--    Read data for LOD 2, i.e. time-dependent xz-, yz-, and xy-slices.
+       IF ( lod == 2 )  THEN
+          CALL get_variable( pids_id, 'ls_forcing_left_u',                                         &
+                             nest_offl%u_l,                                                        & ! array to be read
+                             MERGE( nys+1, 1, bc_dirichlet_l),                                     & ! start index y direction
+                             MERGE( nzb+1, 1, bc_dirichlet_l),                                     & ! start index z direction
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                          & ! start index time dimension
+                             MERGE( nyn-nys+1, 0, bc_dirichlet_l),                                 & ! number of elements along y
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                             & ! number of elements alogn z
+                             MERGE( 2, 0, bc_dirichlet_l),                                         & ! number of time steps (2 or 0)
+                             .TRUE. )                                                                ! parallel IO when compiled accordingly
+
+          CALL get_variable( pids_id, 'ls_forcing_left_v',                                         &
+                             nest_offl%v_l,                                                        &
+                             MERGE( nysv, 1, bc_dirichlet_l),                                      &
+                             MERGE( nzb+1, 1, bc_dirichlet_l),                                     &
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                          &
+                             MERGE( nyn-nysv+1, 0, bc_dirichlet_l),                                &
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                             &
+                             MERGE( 2, 0, bc_dirichlet_l),                                         &
                              .TRUE. )
-       ENDIF
-
-       IF ( humidity )  THEN
-          CALL get_variable( pids_id, 'ls_forcing_left_qv',                    &
-                             nest_offl%q_left,                                 &
-                             MERGE( nys+1, 1, bc_dirichlet_l),                 &
-                             MERGE( nzb+1, 1, bc_dirichlet_l),                 &
-                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),      &
-                             MERGE( nyn-nys+1, 0, bc_dirichlet_l),             &
-                             MERGE( nest_offl%nzu, 0, bc_dirichlet_l),         &
-                             MERGE( 2, 0, bc_dirichlet_l),                     &
+
+          CALL get_variable( pids_id, 'ls_forcing_left_w',                                         &
+                             nest_offl%w_l,                                                        &
+                             MERGE( nys+1, 1, bc_dirichlet_l),                                     &
+                             MERGE( nzb+1, 1, bc_dirichlet_l),                                     &
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                          &
+                             MERGE( nyn-nys+1, 0, bc_dirichlet_l),                                 &
+                             MERGE( nest_offl%nzw, 0, bc_dirichlet_l),                             &
+                             MERGE( 2, 0, bc_dirichlet_l),                                         &
+                             .TRUE. )   
+
+          IF ( .NOT. neutral )  THEN
+             CALL get_variable( pids_id, 'ls_forcing_left_pt',                                     &
+                                nest_offl%pt_l,                                                    &
+                                MERGE( nys+1, 1, bc_dirichlet_l),                                  &
+                                MERGE( nzb+1, 1, bc_dirichlet_l),                                  &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                       &
+                                MERGE( nyn-nys+1, 0, bc_dirichlet_l),                              &
+                                MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                          &
+                                MERGE( 2, 0, bc_dirichlet_l),                                      &
+                                .TRUE. )
+          ENDIF
+
+          IF ( humidity )  THEN
+             CALL get_variable( pids_id, 'ls_forcing_left_qv',                                     &
+                                nest_offl%q_l,                                                     &
+                                MERGE( nys+1, 1, bc_dirichlet_l),                                  &
+                                MERGE( nzb+1, 1, bc_dirichlet_l),                                  &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                       &
+                                MERGE( nyn-nys+1, 0, bc_dirichlet_l),                              &
+                                MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                          &
+                                MERGE( 2, 0, bc_dirichlet_l),                                      &
+                                .TRUE. )
+          ENDIF
+
+          IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+             DO  n = 1, UBOUND(nest_offl%var_names_chem_l, 1)
+                IF ( check_existence( nest_offl%var_names,                                         &
+                                      nest_offl%var_names_chem_l(n) ) )  THEN
+                   CALL get_variable( pids_id,                                                     &
+                                      TRIM( nest_offl%var_names_chem_l(n) ),                       &
+                                      nest_offl%chem_l(:,:,:,n),                                   &
+                                      MERGE( nys+1, 1, bc_dirichlet_l),                            &
+                                      MERGE( nzb+1, 1, bc_dirichlet_l),                            &
+                                      MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                 &
+                                      MERGE( nyn-nys+1, 0, bc_dirichlet_l),                        &
+                                      MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                    &
+                                      MERGE( 2, 0, bc_dirichlet_l),                                &
+                                      .TRUE. )
+                   nest_offl%chem_from_file_l(n) = .TRUE.
+                ENDIF
+             ENDDO
+          ENDIF
+!
+!--       Read data for eastern boundary    
+          CALL get_variable( pids_id, 'ls_forcing_right_u',                                        &
+                             nest_offl%u_r,                                                        &
+                             MERGE( nys+1, 1, bc_dirichlet_r),                                     &
+                             MERGE( nzb+1, 1, bc_dirichlet_r),                                     &
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),                          &
+                             MERGE( nyn-nys+1, 0, bc_dirichlet_r),                                 &
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_r),                             &
+                             MERGE( 2, 0, bc_dirichlet_r),                                         &
                              .TRUE. )
-       ENDIF
-
-       IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
-          DO  n = 1, UBOUND(nest_offl%var_names_chem_l, 1)
-             IF ( check_existence( nest_offl%var_names,                        &
-                                   nest_offl%var_names_chem_l(n) ) )  THEN
-                CALL get_variable( pids_id,                                    &
-                           TRIM( nest_offl%var_names_chem_l(n) ),              &
-                           nest_offl%chem_left(:,:,:,n),                       &
-                           MERGE( nys+1, 1, bc_dirichlet_l),                   &
-                           MERGE( nzb+1, 1, bc_dirichlet_l),                   &
-                           MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),        &
-                           MERGE( nyn-nys+1, 0, bc_dirichlet_l),               &
-                           MERGE( nest_offl%nzu, 0, bc_dirichlet_l),           &
-                           MERGE( 2, 0, bc_dirichlet_l),                       &
-                           .TRUE. )
-                nest_offl%chem_from_file_l(n) = .TRUE.
-             ENDIF
-          ENDDO
-       ENDIF
-!
-!--    Read data for eastern boundary    
-       CALL get_variable( pids_id, 'ls_forcing_right_u',                       &
-                          nest_offl%u_right,                                   &
-                          MERGE( nys+1, 1, bc_dirichlet_r),                    &
-                          MERGE( nzb+1, 1, bc_dirichlet_r),                    &
-                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),         &
-                          MERGE( nyn-nys+1, 0, bc_dirichlet_r),                &
-                          MERGE( nest_offl%nzu, 0, bc_dirichlet_r),            &
-                          MERGE( 2, 0, bc_dirichlet_r),                        &
-                          .TRUE. )                                             
-      
-       CALL get_variable( pids_id, 'ls_forcing_right_v',                       &
-                          nest_offl%v_right,                                   &
-                          MERGE( nysv, 1, bc_dirichlet_r),                     &
-                          MERGE( nzb+1, 1, bc_dirichlet_r),                    &
-                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),         &
-                          MERGE( nyn-nysv+1, 0, bc_dirichlet_r),               &
-                          MERGE( nest_offl%nzu, 0, bc_dirichlet_r),            &
-                          MERGE( 2, 0, bc_dirichlet_r),                        &
-                          .TRUE. )                                             
-
-       CALL get_variable( pids_id, 'ls_forcing_right_w',                       &
-                          nest_offl%w_right,                                   &
-                          MERGE( nys+1, 1, bc_dirichlet_r),                    &
-                          MERGE( nzb+1, 1, bc_dirichlet_r),                    &
-                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),         &
-                          MERGE( nyn-nys+1, 0, bc_dirichlet_r),                &
-                          MERGE( nest_offl%nzw, 0, bc_dirichlet_r),            &
-                          MERGE( 2, 0, bc_dirichlet_r),                        &
-                          .TRUE. )   
-
-       IF ( .NOT. neutral )  THEN
-          CALL get_variable( pids_id, 'ls_forcing_right_pt',                   &
-                             nest_offl%pt_right,                               &
-                             MERGE( nys+1, 1, bc_dirichlet_r),                 &
-                             MERGE( nzb+1, 1, bc_dirichlet_r),                 &
-                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),      &
-                             MERGE( nyn-nys+1, 0, bc_dirichlet_r),             &
-                             MERGE( nest_offl%nzu, 0, bc_dirichlet_r),         &
-                             MERGE( 2, 0, bc_dirichlet_r),                     &
+
+          CALL get_variable( pids_id, 'ls_forcing_right_v',                                        &
+                             nest_offl%v_r,                                                        &
+                             MERGE( nysv, 1, bc_dirichlet_r),                                      &
+                             MERGE( nzb+1, 1, bc_dirichlet_r),                                     &
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),                          &
+                             MERGE( nyn-nysv+1, 0, bc_dirichlet_r),                                &
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_r),                             &
+                             MERGE( 2, 0, bc_dirichlet_r),                                         &
                              .TRUE. )
-       ENDIF
-
-       IF ( humidity )  THEN
-          CALL get_variable( pids_id, 'ls_forcing_right_qv',                   &
-                             nest_offl%q_right,                                &
-                             MERGE( nys+1, 1, bc_dirichlet_r),                 &
-                             MERGE( nzb+1, 1, bc_dirichlet_r),                 &
-                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),      &
-                             MERGE( nyn-nys+1, 0, bc_dirichlet_r),             &
-                             MERGE( nest_offl%nzu, 0, bc_dirichlet_r),         &
-                             MERGE( 2, 0, bc_dirichlet_r),                     &
+
+          CALL get_variable( pids_id, 'ls_forcing_right_w',                                        &
+                             nest_offl%w_r,                                                        &
+                             MERGE( nys+1, 1, bc_dirichlet_r),                                     &
+                             MERGE( nzb+1, 1, bc_dirichlet_r),                                     &
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),                          &
+                             MERGE( nyn-nys+1, 0, bc_dirichlet_r),                                 &
+                             MERGE( nest_offl%nzw, 0, bc_dirichlet_r),                             &
+                             MERGE( 2, 0, bc_dirichlet_r),                                         &
                              .TRUE. )
-       ENDIF
-
-       IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
-          DO  n = 1, UBOUND(nest_offl%var_names_chem_r, 1)
-             IF ( check_existence( nest_offl%var_names,                        &
-                                   nest_offl%var_names_chem_r(n) ) )  THEN
-                CALL get_variable( pids_id,                                    &
-                           TRIM( nest_offl%var_names_chem_r(n) ),              &
-                           nest_offl%chem_right(:,:,:,n),                      &
-                           MERGE( nys+1, 1, bc_dirichlet_r),                   &
-                           MERGE( nzb+1, 1, bc_dirichlet_r),                   &
-                           MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),        &
-                           MERGE( nyn-nys+1, 0, bc_dirichlet_r),               &
-                           MERGE( nest_offl%nzu, 0, bc_dirichlet_r),           &
-                           MERGE( 2, 0, bc_dirichlet_r),                       &
-                           .TRUE. )
-                nest_offl%chem_from_file_r(n) = .TRUE.
-             ENDIF
-          ENDDO
-       ENDIF
-!
-!--    Read data for northern boundary
-       CALL get_variable( pids_id, 'ls_forcing_north_u',                       & ! array to be read
-                          nest_offl%u_north,                                   & ! start index x direction
-                          MERGE( nxlu, 1, bc_dirichlet_n ),                    & ! start index z direction
-                          MERGE( nzb+1, 1, bc_dirichlet_n ),                   & ! start index time dimension
-                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),        & ! number of elements along x
-                          MERGE( nxr-nxlu+1, 0, bc_dirichlet_n ),              & ! number of elements alogn z 
-                          MERGE( nest_offl%nzu, 0, bc_dirichlet_n ),           & ! number of time steps (2 or 0)
-                          MERGE( 2, 0, bc_dirichlet_n ),                       & ! parallel IO when compiled accordingly
-                          .TRUE. )
-
-       CALL get_variable( pids_id, 'ls_forcing_north_v',                       & ! array to be read
-                          nest_offl%v_north,                                   & ! start index x direction
-                          MERGE( nxl+1, 1, bc_dirichlet_n ),                   & ! start index z direction
-                          MERGE( nzb+1, 1, bc_dirichlet_n ),                   & ! start index time dimension
-                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),        & ! number of elements along x
-                          MERGE( nxr-nxl+1, 0, bc_dirichlet_n ),               & ! number of elements alogn z 
-                          MERGE( nest_offl%nzu, 0, bc_dirichlet_n ),           & ! number of time steps (2 or 0)
-                          MERGE( 2, 0, bc_dirichlet_n ),                       & ! parallel IO when compiled accordingly
-                          .TRUE. )
-
-       CALL get_variable( pids_id, 'ls_forcing_north_w',                       & ! array to be read
-                          nest_offl%w_north,                                   & ! start index x direction
-                          MERGE( nxl+1, 1, bc_dirichlet_n ),                   & ! start index z direction
-                          MERGE( nzb+1, 1, bc_dirichlet_n ),                   & ! start index time dimension
-                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),        & ! number of elements along x
-                          MERGE( nxr-nxl+1, 0, bc_dirichlet_n ),               & ! number of elements alogn z 
-                          MERGE( nest_offl%nzw, 0, bc_dirichlet_n ),           & ! number of time steps (2 or 0)
-                          MERGE( 2, 0, bc_dirichlet_n ),                       & ! parallel IO when compiled accordingly
-                          .TRUE. )
-
-       IF ( .NOT. neutral )  THEN
-          CALL get_variable( pids_id, 'ls_forcing_north_pt',                   & ! array to be read
-                             nest_offl%pt_north,                               & ! start index x direction
-                             MERGE( nxl+1, 1, bc_dirichlet_n ),                & ! start index z direction
-                             MERGE( nzb+1, 1, bc_dirichlet_n ),                & ! start index time dimension
-                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),     & ! number of elements along x
-                             MERGE( nxr-nxl+1, 0, bc_dirichlet_n ),            & ! number of elements alogn z 
-                             MERGE( nest_offl%nzu, 0, bc_dirichlet_n ),        & ! number of time steps (2 or 0)
-                             MERGE( 2, 0, bc_dirichlet_n ),                    & ! parallel IO when compiled accordingly
+
+          IF ( .NOT. neutral )  THEN
+             CALL get_variable( pids_id, 'ls_forcing_right_pt',                                    &
+                                nest_offl%pt_r,                                                    &
+                                MERGE( nys+1, 1, bc_dirichlet_r),                                  &
+                                MERGE( nzb+1, 1, bc_dirichlet_r),                                  &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),                       &
+                                MERGE( nyn-nys+1, 0, bc_dirichlet_r),                              &
+                                MERGE( nest_offl%nzu, 0, bc_dirichlet_r),                          &
+                                MERGE( 2, 0, bc_dirichlet_r),                                      &
+                                .TRUE. )
+          ENDIF
+
+          IF ( humidity )  THEN
+             CALL get_variable( pids_id, 'ls_forcing_right_qv',                                    &
+                                nest_offl%q_r,                                                     &
+                                MERGE( nys+1, 1, bc_dirichlet_r),                                  &
+                                MERGE( nzb+1, 1, bc_dirichlet_r),                                  &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),                       &
+                                MERGE( nyn-nys+1, 0, bc_dirichlet_r),                              &
+                                MERGE( nest_offl%nzu, 0, bc_dirichlet_r),                          &
+                                MERGE( 2, 0, bc_dirichlet_r),                                      &
+                                .TRUE. )
+          ENDIF
+
+          IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+             DO  n = 1, UBOUND(nest_offl%var_names_chem_r, 1)
+                IF ( check_existence( nest_offl%var_names,                                         &
+                                      nest_offl%var_names_chem_r(n) ) )  THEN
+                   CALL get_variable( pids_id,                                                     &
+                                      TRIM( nest_offl%var_names_chem_r(n) ),                       &
+                                      nest_offl%chem_r(:,:,:,n),                                   &
+                                      MERGE( nys+1, 1, bc_dirichlet_r),                            &
+                                      MERGE( nzb+1, 1, bc_dirichlet_r),                            &
+                                      MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),                 &
+                                      MERGE( nyn-nys+1, 0, bc_dirichlet_r),                        &
+                                      MERGE( nest_offl%nzu, 0, bc_dirichlet_r),                    &
+                                      MERGE( 2, 0, bc_dirichlet_r),                                &
+                                      .TRUE. )
+                   nest_offl%chem_from_file_r(n) = .TRUE.
+                ENDIF
+             ENDDO
+          ENDIF
+!
+!--       Read data for northern boundary
+          CALL get_variable( pids_id, 'ls_forcing_north_u',                                        &
+                             nest_offl%u_n,                                                        &
+                             MERGE( nxlu, 1, bc_dirichlet_n ),                                     &
+                             MERGE( nzb+1, 1, bc_dirichlet_n ),                                    &
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),                         &
+                             MERGE( nxr-nxlu+1, 0, bc_dirichlet_n ),                               &
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_n ),                            &
+                             MERGE( 2, 0, bc_dirichlet_n ),                                        &
                              .TRUE. )
-       ENDIF
-       IF ( humidity )  THEN
-          CALL get_variable( pids_id, 'ls_forcing_north_qv',                   & ! array to be read
-                             nest_offl%q_north,                                & ! start index x direction
-                             MERGE( nxl+1, 1, bc_dirichlet_n ),                & ! start index z direction
-                             MERGE( nzb+1, 1, bc_dirichlet_n ),                & ! start index time dimension
-                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),     & ! number of elements along x
-                             MERGE( nxr-nxl+1, 0, bc_dirichlet_n ),            & ! number of elements alogn z 
-                             MERGE( nest_offl%nzu, 0, bc_dirichlet_n ),        & ! number of time steps (2 or 0)
-                             MERGE( 2, 0, bc_dirichlet_n ),                    & ! parallel IO when compiled accordingly
+
+          CALL get_variable( pids_id, 'ls_forcing_north_v',                                        &
+                             nest_offl%v_n,                                                        &
+                             MERGE( nxl+1, 1, bc_dirichlet_n ),                                    &
+                             MERGE( nzb+1, 1, bc_dirichlet_n ),                                    &
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),                         &
+                             MERGE( nxr-nxl+1, 0, bc_dirichlet_n ),                                &
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_n ),                            &
+                             MERGE( 2, 0, bc_dirichlet_n ),                                        &
                              .TRUE. )
-       ENDIF
-
-       IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
-          DO  n = 1, UBOUND(nest_offl%var_names_chem_n, 1)
-             IF ( check_existence( nest_offl%var_names,                        &
-                                   nest_offl%var_names_chem_n(n) ) )  THEN
-                CALL get_variable( pids_id,                                    &
-                           TRIM( nest_offl%var_names_chem_n(n) ),              &
-                           nest_offl%chem_north(:,:,:,n),                      &
-                           MERGE( nxl+1, 1, bc_dirichlet_n ),                  &
-                           MERGE( nzb+1, 1, bc_dirichlet_n ),                  &
-                           MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),       &
-                           MERGE( nxr-nxl+1, 0, bc_dirichlet_n ),              &
-                           MERGE( nest_offl%nzu, 0, bc_dirichlet_n ),          &
-                           MERGE( 2, 0, bc_dirichlet_n ),                      &
-                           .TRUE. )
-                nest_offl%chem_from_file_n(n) = .TRUE.
-             ENDIF
-          ENDDO
-       ENDIF
-!
-!--    Read data for southern boundary
-       CALL get_variable( pids_id, 'ls_forcing_south_u',                       & ! array to be read
-                          nest_offl%u_south,                                   & ! start index x direction
-                          MERGE( nxlu, 1, bc_dirichlet_s ),                    & ! start index z direction
-                          MERGE( nzb+1, 1, bc_dirichlet_s ),                   & ! start index time dimension
-                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),        & ! number of elements along x
-                          MERGE( nxr-nxlu+1, 0, bc_dirichlet_s ),              & ! number of elements alogn z 
-                          MERGE( nest_offl%nzu, 0, bc_dirichlet_s ),           & ! number of time steps (2 or 0)
-                          MERGE( 2, 0, bc_dirichlet_s ),                       & ! parallel IO when compiled accordingly
-                          .TRUE. )
-
-       CALL get_variable( pids_id, 'ls_forcing_south_v',                       & ! array to be read
-                          nest_offl%v_south,                                   & ! start index x direction
-                          MERGE( nxl+1, 1, bc_dirichlet_s ),                   & ! start index z direction
-                          MERGE( nzb+1, 1, bc_dirichlet_s ),                   & ! start index time dimension
-                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),        & ! number of elements along x
-                          MERGE( nxr-nxl+1, 0, bc_dirichlet_s ),               & ! number of elements alogn z 
-                          MERGE( nest_offl%nzu, 0, bc_dirichlet_s ),           & ! number of time steps (2 or 0)
-                          MERGE( 2, 0, bc_dirichlet_s ),                       & ! parallel IO when compiled accordingly
-                          .TRUE. )
-
-       CALL get_variable( pids_id, 'ls_forcing_south_w',                       & ! array to be read
-                          nest_offl%w_south,                                   & ! start index x direction
-                          MERGE( nxl+1, 1, bc_dirichlet_s ),                   & ! start index z direction
-                          MERGE( nzb+1, 1, bc_dirichlet_s ),                   & ! start index time dimension
-                          MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),        & ! number of elements along x
-                          MERGE( nxr-nxl+1, 0, bc_dirichlet_s ),               & ! number of elements alogn z 
-                          MERGE( nest_offl%nzw, 0, bc_dirichlet_s ),           & ! number of time steps (2 or 0)
-                          MERGE( 2, 0, bc_dirichlet_s ),                       & ! parallel IO when compiled accordingly
-                          .TRUE. )
-
-       IF ( .NOT. neutral )  THEN
-          CALL get_variable( pids_id, 'ls_forcing_south_pt',                   & ! array to be read
-                             nest_offl%pt_south,                               & ! start index x direction
-                             MERGE( nxl+1, 1, bc_dirichlet_s ),                & ! start index z direction
-                             MERGE( nzb+1, 1, bc_dirichlet_s ),                & ! start index time dimension
-                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),     & ! number of elements along x
-                             MERGE( nxr-nxl+1, 0, bc_dirichlet_s ),            & ! number of elements alogn z 
-                             MERGE( nest_offl%nzu, 0, bc_dirichlet_s ),        & ! number of time steps (2 or 0)
-                             MERGE( 2, 0, bc_dirichlet_s ),                    & ! parallel IO when compiled accordingly
+
+          CALL get_variable( pids_id, 'ls_forcing_north_w',                                        &
+                             nest_offl%w_n,                                                        &
+                             MERGE( nxl+1, 1, bc_dirichlet_n ),                                    &
+                             MERGE( nzb+1, 1, bc_dirichlet_n ),                                    &
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),                         &
+                             MERGE( nxr-nxl+1, 0, bc_dirichlet_n ),                                &
+                             MERGE( nest_offl%nzw, 0, bc_dirichlet_n ),                            &
+                             MERGE( 2, 0, bc_dirichlet_n ),                                        &
                              .TRUE. )
-       ENDIF
-       IF ( humidity )  THEN
-          CALL get_variable( pids_id, 'ls_forcing_south_qv',                   & ! array to be read
-                             nest_offl%q_south,                                & ! start index x direction
-                             MERGE( nxl+1, 1, bc_dirichlet_s ),                & ! start index z direction
-                             MERGE( nzb+1, 1, bc_dirichlet_s ),                & ! start index time dimension
-                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),     & ! number of elements along x
-                             MERGE( nxr-nxl+1, 0, bc_dirichlet_s ),            & ! number of elements alogn z 
-                             MERGE( nest_offl%nzu, 0, bc_dirichlet_s ),        & ! number of time steps (2 or 0)
-                             MERGE( 2, 0, bc_dirichlet_s ),                    & ! parallel IO when compiled accordingly
+
+          IF ( .NOT. neutral )  THEN
+             CALL get_variable( pids_id, 'ls_forcing_north_pt',                                    &
+                                nest_offl%pt_n,                                                    &
+                                MERGE( nxl+1, 1, bc_dirichlet_n ),                                 &
+                                MERGE( nzb+1, 1, bc_dirichlet_n ),                                 &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),                      &
+                                MERGE( nxr-nxl+1, 0, bc_dirichlet_n ),                             &
+                                MERGE( nest_offl%nzu, 0, bc_dirichlet_n ),                         &
+                                MERGE( 2, 0, bc_dirichlet_n ),                                     &
+                                .TRUE. )
+          ENDIF
+          IF ( humidity )  THEN
+             CALL get_variable( pids_id, 'ls_forcing_north_qv',                                    &
+                                nest_offl%q_n,                                                     &
+                                MERGE( nxl+1, 1, bc_dirichlet_n ),                                 &
+                                MERGE( nzb+1, 1, bc_dirichlet_n ),                                 &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),                      &
+                                MERGE( nxr-nxl+1, 0, bc_dirichlet_n ),                             &
+                                MERGE( nest_offl%nzu, 0, bc_dirichlet_n ),                         &
+                                MERGE( 2, 0, bc_dirichlet_n ),                                     &
+                                .TRUE. )
+          ENDIF
+
+          IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+             DO  n = 1, UBOUND(nest_offl%var_names_chem_n, 1)
+                IF ( check_existence( nest_offl%var_names,                                         &
+                                      nest_offl%var_names_chem_n(n) ) )  THEN
+                   CALL get_variable( pids_id,                                                     &
+                                      TRIM( nest_offl%var_names_chem_n(n) ),                       &
+                                      nest_offl%chem_n(:,:,:,n),                                   &
+                                      MERGE( nxl+1, 1, bc_dirichlet_n ),                           &
+                                      MERGE( nzb+1, 1, bc_dirichlet_n ),                           &
+                                      MERGE( nest_offl%tind+1, 1, bc_dirichlet_n ),                &
+                                      MERGE( nxr-nxl+1, 0, bc_dirichlet_n ),                       &
+                                      MERGE( nest_offl%nzu, 0, bc_dirichlet_n ),                   &
+                                      MERGE( 2, 0, bc_dirichlet_n ),                               &
+                                      .TRUE. )
+                   nest_offl%chem_from_file_n(n) = .TRUE.
+                ENDIF
+             ENDDO
+          ENDIF
+!
+!--       Read data for southern boundary
+          CALL get_variable( pids_id, 'ls_forcing_south_u',                                        &
+                             nest_offl%u_s,                                                        &
+                             MERGE( nxlu, 1, bc_dirichlet_s ),                                     &
+                             MERGE( nzb+1, 1, bc_dirichlet_s ),                                    &
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),                         &
+                             MERGE( nxr-nxlu+1, 0, bc_dirichlet_s ),                               &
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_s ),                            &
+                             MERGE( 2, 0, bc_dirichlet_s ),                                        &
                              .TRUE. )
-       ENDIF
-
-       IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
-          DO  n = 1, UBOUND(nest_offl%var_names_chem_s, 1)
-             IF ( check_existence( nest_offl%var_names,                        &
-                                   nest_offl%var_names_chem_s(n) ) )  THEN
-                CALL get_variable( pids_id,                                    &
-                           TRIM( nest_offl%var_names_chem_s(n) ),              &
-                           nest_offl%chem_south(:,:,:,n),                      &
-                           MERGE( nxl+1, 1, bc_dirichlet_s ),                  &
-                           MERGE( nzb+1, 1, bc_dirichlet_s ),                  &
-                           MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),       &
-                           MERGE( nxr-nxl+1, 0, bc_dirichlet_s ),              &
-                           MERGE( nest_offl%nzu, 0, bc_dirichlet_s ),          &
-                           MERGE( 2, 0, bc_dirichlet_s ),                      &
-                           .TRUE. )
-                nest_offl%chem_from_file_s(n) = .TRUE.
-             ENDIF
-          ENDDO
-       ENDIF
-!
-!--    Top boundary
-       CALL get_variable( pids_id, 'ls_forcing_top_u',                         &
-                             nest_offl%u_top(0:1,nys:nyn,nxlu:nxr),            &
-                             nxlu, nys+1, nest_offl%tind+1,                    &
+
+          CALL get_variable( pids_id, 'ls_forcing_south_v',                                        &
+                             nest_offl%v_s,                                                        &
+                             MERGE( nxl+1, 1, bc_dirichlet_s ),                                    &
+                             MERGE( nzb+1, 1, bc_dirichlet_s ),                                    &
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),                         &
+                             MERGE( nxr-nxl+1, 0, bc_dirichlet_s ),                                &
+                             MERGE( nest_offl%nzu, 0, bc_dirichlet_s ),                            &
+                             MERGE( 2, 0, bc_dirichlet_s ),                                        &
+                             .TRUE. )
+
+          CALL get_variable( pids_id, 'ls_forcing_south_w',                                        &
+                             nest_offl%w_s,                                                        &
+                             MERGE( nxl+1, 1, bc_dirichlet_s ),                                    &
+                             MERGE( nzb+1, 1, bc_dirichlet_s ),                                    &
+                             MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),                         &
+                             MERGE( nxr-nxl+1, 0, bc_dirichlet_s ),                                &
+                             MERGE( nest_offl%nzw, 0, bc_dirichlet_s ),                            &
+                             MERGE( 2, 0, bc_dirichlet_s ),                                        &
+                             .TRUE. )
+
+          IF ( .NOT. neutral )  THEN
+             CALL get_variable( pids_id, 'ls_forcing_south_pt',                                    &
+                                nest_offl%pt_s,                                                    &
+                                MERGE( nxl+1, 1, bc_dirichlet_s ),                                 &
+                                MERGE( nzb+1, 1, bc_dirichlet_s ),                                 &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),                      &
+                                MERGE( nxr-nxl+1, 0, bc_dirichlet_s ),                             &
+                                MERGE( nest_offl%nzu, 0, bc_dirichlet_s ),                         &
+                                MERGE( 2, 0, bc_dirichlet_s ),                                     &
+                                .TRUE. )
+          ENDIF
+          IF ( humidity )  THEN
+             CALL get_variable( pids_id, 'ls_forcing_south_qv',                                    &
+                                nest_offl%q_s,                                                     &
+                                MERGE( nxl+1, 1, bc_dirichlet_s ),                                 &
+                                MERGE( nzb+1, 1, bc_dirichlet_s ),                                 &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),                      &
+                                MERGE( nxr-nxl+1, 0, bc_dirichlet_s ),                             &
+                                MERGE( nest_offl%nzu, 0, bc_dirichlet_s ),                         &
+                                MERGE( 2, 0, bc_dirichlet_s ),                                     &
+                                .TRUE. )
+          ENDIF
+
+          IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+             DO  n = 1, UBOUND(nest_offl%var_names_chem_s, 1)
+                IF ( check_existence( nest_offl%var_names,                                         &
+                                      nest_offl%var_names_chem_s(n) ) )  THEN
+                   CALL get_variable( pids_id,                                                     &
+                                      TRIM( nest_offl%var_names_chem_s(n) ),                       &
+                                      nest_offl%chem_s(:,:,:,n),                                   &
+                                      MERGE( nxl+1, 1, bc_dirichlet_s ),                           &
+                                      MERGE( nzb+1, 1, bc_dirichlet_s ),                           &
+                                      MERGE( nest_offl%tind+1, 1, bc_dirichlet_s ),                &
+                                      MERGE( nxr-nxl+1, 0, bc_dirichlet_s ),                       &
+                                      MERGE( nest_offl%nzu, 0, bc_dirichlet_s ),                   &
+                                      MERGE( 2, 0, bc_dirichlet_s ),                               &
+                                      .TRUE. )
+                   nest_offl%chem_from_file_s(n) = .TRUE.
+                ENDIF
+             ENDDO
+          ENDIF
+!
+!--       Top boundary
+          CALL get_variable( pids_id, 'ls_forcing_top_u',                                          &
+                             nest_offl%u_top(0:1,nys:nyn,nxlu:nxr),                                &
+                             nxlu, nys+1, nest_offl%tind+1,                                        &
                              nxr-nxlu+1, nyn-nys+1, 2, .TRUE. )
 
-       CALL get_variable( pids_id, 'ls_forcing_top_v',                         &
-                             nest_offl%v_top(0:1,nysv:nyn,nxl:nxr),            &
-                             nxl+1, nysv, nest_offl%tind+1,                    &
+          CALL get_variable( pids_id, 'ls_forcing_top_v',                                          &
+                             nest_offl%v_top(0:1,nysv:nyn,nxl:nxr),                                &
+                             nxl+1, nysv, nest_offl%tind+1,                                        &
                              nxr-nxl+1, nyn-nysv+1, 2, .TRUE. )
 
-       CALL get_variable( pids_id, 'ls_forcing_top_w',                         &
-                             nest_offl%w_top(0:1,nys:nyn,nxl:nxr),             &
-                             nxl+1, nys+1, nest_offl%tind+1,                   &
+          CALL get_variable( pids_id, 'ls_forcing_top_w',                                          &
+                             nest_offl%w_top(0:1,nys:nyn,nxl:nxr),                                 &
+                             nxl+1, nys+1, nest_offl%tind+1,                                       &
                              nxr-nxl+1, nyn-nys+1, 2, .TRUE. )
 
-       IF ( .NOT. neutral )  THEN
-          CALL get_variable( pids_id, 'ls_forcing_top_pt',                     &
-                                nest_offl%pt_top(0:1,nys:nyn,nxl:nxr),         &
-                                nxl+1, nys+1, nest_offl%tind+1,                &
+          IF ( .NOT. neutral )  THEN
+             CALL get_variable( pids_id, 'ls_forcing_top_pt',                                      &
+                                nest_offl%pt_top(0:1,nys:nyn,nxl:nxr),                             &
+                                nxl+1, nys+1, nest_offl%tind+1,                                    &
                                 nxr-nxl+1, nyn-nys+1, 2, .TRUE. )
-       ENDIF
-       IF ( humidity )  THEN
-          CALL get_variable( pids_id, 'ls_forcing_top_qv',                     &
-                                nest_offl%q_top(0:1,nys:nyn,nxl:nxr),          &
-                                nxl+1, nys+1, nest_offl%tind+1,                &
+          ENDIF
+          IF ( humidity )  THEN
+             CALL get_variable( pids_id, 'ls_forcing_top_qv',                                      &
+                                nest_offl%q_top(0:1,nys:nyn,nxl:nxr),                              &
+                                nxl+1, nys+1, nest_offl%tind+1,                                    &
                                 nxr-nxl+1, nyn-nys+1, 2, .TRUE. )
-       ENDIF
-
-       IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
-          DO  n = 1, UBOUND(nest_offl%var_names_chem_t, 1)
-             IF ( check_existence( nest_offl%var_names,                        &
-                                   nest_offl%var_names_chem_t(n) ) )  THEN
-                CALL get_variable( pids_id,                                    &
-                              TRIM( nest_offl%var_names_chem_t(n) ),           &
-                              nest_offl%chem_top(0:1,nys:nyn,nxl:nxr,n),       &
-                              nxl+1, nys+1, nest_offl%tind+1,                  &
-                              nxr-nxl+1, nyn-nys+1, 2, .TRUE. )
-                nest_offl%chem_from_file_t(n) = .TRUE.
-             ENDIF
-          ENDDO
-       ENDIF
+          ENDIF
+
+          IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+             DO  n = 1, UBOUND(nest_offl%var_names_chem_t, 1)
+                IF ( check_existence( nest_offl%var_names,                                         &
+                                      nest_offl%var_names_chem_t(n) ) )  THEN
+                   CALL get_variable( pids_id,                                                     &
+                                 TRIM( nest_offl%var_names_chem_t(n) ),                            &
+                                 nest_offl%chem_top(0:1,nys:nyn,nxl:nxr,n),                        &
+                                 nxl+1, nys+1, nest_offl%tind+1,                                   &
+                                 nxr-nxl+1, nyn-nys+1, 2, .TRUE. )
+                   nest_offl%chem_from_file_t(n) = .TRUE.
+                ENDIF
+             ENDDO
+          ENDIF
+!
+!--    Read data for LOD 1, i.e. time-dependent profiles. In constrast to LOD 2 where the amount of
+!--    IO is larger, only the respective boundary processes read the data.
+       ELSE
+          IF ( bc_dirichlet_l )  THEN
+             CALL get_variable( pids_id, 'ls_forcing_left_u',                                      &
+                                nest_offl%u_l(0:1,:,1:1),                                          & ! array to be read
+                                MERGE( nzb+1, 1, bc_dirichlet_l),                                  & ! start index z direction
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                       & ! start index time dimension
+                                MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                          & ! number of elements along z
+                                MERGE( 2, 0, bc_dirichlet_l) )                                       ! number of time steps (2 or 0)
+             CALL get_variable( pids_id, 'ls_forcing_left_v',                                      &
+                                nest_offl%v_l(0:1,:,1:1),                                          &
+                                MERGE( nzb+1, 1, bc_dirichlet_l),                                  &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                       &
+                                MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                          &
+                                MERGE( 2, 0, bc_dirichlet_l) )
+             CALL get_variable( pids_id, 'ls_forcing_left_w',                                      &
+                                nest_offl%w_l(0:1,:,1:1),                                          &
+                                MERGE( nzb+1, 1, bc_dirichlet_l),                                  &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                       &
+                                MERGE( nest_offl%nzw, 0, bc_dirichlet_l),                          &
+                                MERGE( 2, 0, bc_dirichlet_l) )
+             IF ( .NOT. neutral )  THEN
+                CALL get_variable( pids_id, 'ls_forcing_left_pt',                                  &
+                                   nest_offl%pt_l(0:1,:,1:1),                                      &
+                                   MERGE( nzb+1, 1, bc_dirichlet_l),                               &
+                                   MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                    &
+                                   MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                       &
+                                   MERGE( 2, 0, bc_dirichlet_l) ) 
+             ENDIF
+             IF ( humidity )  THEN
+                CALL get_variable( pids_id, 'ls_forcing_left_qv',                                  &
+                                   nest_offl%q_l(0:1,:,1:1),                                       &
+                                   MERGE( nzb+1, 1, bc_dirichlet_l),                               &
+                                   MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),                    &
+                                   MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                       &
+                                   MERGE( 2, 0, bc_dirichlet_l) )
+             ENDIF
+             IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+                DO  n = 1, UBOUND(nest_offl%var_names_chem_t, 1)
+                   IF ( check_existence( nest_offl%var_names,                                      &
+                                         nest_offl%var_names_chem_t(n) ) )  THEN
+                      CALL get_variable( pids_id, TRIM( nest_offl%var_names_chem_t(n) ),           &
+                                         nest_offl%chem_l(0:1,:,1:1,n),                            &
+                                         MERGE( nzb+1, 1, bc_dirichlet_l),                         &
+                                         MERGE( nest_offl%tind+1, 1, bc_dirichlet_l),              &
+                                         MERGE( nest_offl%nzu, 0, bc_dirichlet_l),                 &
+                                         MERGE( 2, 0, bc_dirichlet_l) )
+                      nest_offl%chem_from_file_l(n) = .TRUE.
+                   ENDIF
+                ENDDO
+             ENDIF
+          ENDIF
+          IF ( bc_dirichlet_r )  THEN
+             CALL get_variable( pids_id, 'ls_forcing_right_u',                                     &
+                                nest_offl%u_r(0:1,:,1:1),                                          &
+                                MERGE( nzb+1, 1, bc_dirichlet_r),                                  &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),                       &
+                                MERGE( nest_offl%nzu, 0, bc_dirichlet_r),                          &
+                                MERGE( 2, 0, bc_dirichlet_r) )
+             CALL get_variable( pids_id, 'ls_forcing_right_v',                                     &
+                                nest_offl%v_r(0:1,:,1:1),                                          &
+                                MERGE( nzb+1, 1, bc_dirichlet_r),                                  &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),                       &
+                                MERGE( nest_offl%nzu, 0, bc_dirichlet_r),                          &
+                                MERGE( 2, 0, bc_dirichlet_r) )
+             CALL get_variable( pids_id, 'ls_forcing_right_w',                                     &
+                                nest_offl%w_r(0:1,:,1:1),                                          &
+                                MERGE( nzb+1, 1, bc_dirichlet_r),                                  &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),                       &
+                                MERGE( nest_offl%nzw, 0, bc_dirichlet_r),                          &
+                                MERGE( 2, 0, bc_dirichlet_r) )
+             IF ( .NOT. neutral )  THEN
+                CALL get_variable( pids_id, 'ls_forcing_right_pt',                                 &
+                                   nest_offl%pt_r(0:1,:,1:1),                                      &
+                                   MERGE( nzb+1, 1, bc_dirichlet_r),                               &
+                                   MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),                    &
+                                   MERGE( nest_offl%nzu, 0, bc_dirichlet_r),                       &
+                                   MERGE( 2, 0, bc_dirichlet_r) ) 
+             ENDIF
+             IF ( humidity )  THEN
+                CALL get_variable( pids_id, 'ls_forcing_right_qv',                                 &
+                                   nest_offl%q_r(0:1,:,1:1),                                       &
+                                   MERGE( nzb+1, 1, bc_dirichlet_r),                               &
+                                   MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),                    &
+                                   MERGE( nest_offl%nzu, 0, bc_dirichlet_r),                       &
+                                   MERGE( 2, 0, bc_dirichlet_r) )
+             ENDIF
+             IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+                DO  n = 1, UBOUND(nest_offl%var_names_chem_t, 1)
+                   IF ( check_existence( nest_offl%var_names,                                      &
+                                         nest_offl%var_names_chem_t(n) ) )  THEN
+                      CALL get_variable( pids_id, TRIM( nest_offl%var_names_chem_t(n) ),           &
+                                         nest_offl%chem_r(0:1,:,1:1,n),                            &
+                                         MERGE( nzb+1, 1, bc_dirichlet_r),                         &
+                                         MERGE( nest_offl%tind+1, 1, bc_dirichlet_r),              &
+                                         MERGE( nest_offl%nzu, 0, bc_dirichlet_r),                 &
+                                         MERGE( 2, 0, bc_dirichlet_r) )
+                      nest_offl%chem_from_file_r(n) = .TRUE.
+                   ENDIF
+                ENDDO
+             ENDIF
+          ENDIF
+          IF ( bc_dirichlet_n )  THEN
+             CALL get_variable( pids_id, 'ls_forcing_north_u',                                     &
+                                nest_offl%u_n(0:1,:,1:1),                                          &
+                                MERGE( nzb+1, 1, bc_dirichlet_n),                                  &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_n),                       &
+                                MERGE( nest_offl%nzu, 0, bc_dirichlet_n),                          &
+                                MERGE( 2, 0, bc_dirichlet_n) )
+             CALL get_variable( pids_id, 'ls_forcing_north_v',                                     &
+                                nest_offl%v_n(0:1,:,1:1),                                          &
+                                MERGE( nzb+1, 1, bc_dirichlet_n),                                  &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_n),                       &
+                                MERGE( nest_offl%nzu, 0, bc_dirichlet_n),                          &
+                                MERGE( 2, 0, bc_dirichlet_n) )
+             CALL get_variable( pids_id, 'ls_forcing_north_w',                                     &
+                                nest_offl%w_n(0:1,:,1:1),                                          &
+                                MERGE( nzb+1, 1, bc_dirichlet_n),                                  &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_n),                       &
+                                MERGE( nest_offl%nzw, 0, bc_dirichlet_n),                          &
+                                MERGE( 2, 0, bc_dirichlet_n) )
+             IF ( .NOT. neutral )  THEN
+                CALL get_variable( pids_id, 'ls_forcing_north_pt',                                 &
+                                   nest_offl%pt_n(0:1,:,1:1),                                      &
+                                   MERGE( nzb+1, 1, bc_dirichlet_n),                               &
+                                   MERGE( nest_offl%tind+1, 1, bc_dirichlet_n),                    &
+                                   MERGE( nest_offl%nzu, 0, bc_dirichlet_n),                       &
+                                   MERGE( 2, 0, bc_dirichlet_n) ) 
+             ENDIF
+             IF ( humidity )  THEN
+                CALL get_variable( pids_id, 'ls_forcing_north_qv',                                 &
+                                   nest_offl%q_n(0:1,:,1:1),                                       &
+                                   MERGE( nzb+1, 1, bc_dirichlet_n),                               &
+                                   MERGE( nest_offl%tind+1, 1, bc_dirichlet_n),                    &
+                                   MERGE( nest_offl%nzu, 0, bc_dirichlet_n),                       &
+                                   MERGE( 2, 0, bc_dirichlet_n) )
+             ENDIF
+             IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+                DO  n = 1, UBOUND(nest_offl%var_names_chem_t, 1)
+                   IF ( check_existence( nest_offl%var_names,                                      &
+                                         nest_offl%var_names_chem_t(n) ) )  THEN
+                      CALL get_variable( pids_id, TRIM( nest_offl%var_names_chem_t(n) ),           &
+                                         nest_offl%chem_n(0:1,:,1:1,n),                            &
+                                         MERGE( nzb+1, 1, bc_dirichlet_n),                         &
+                                         MERGE( nest_offl%tind+1, 1, bc_dirichlet_n),              &
+                                         MERGE( nest_offl%nzu, 0, bc_dirichlet_n),                 &
+                                         MERGE( 2, 0, bc_dirichlet_n) )
+                      nest_offl%chem_from_file_n(n) = .TRUE.
+                   ENDIF
+                ENDDO
+             ENDIF
+          ENDIF
+          IF ( bc_dirichlet_s )  THEN
+             CALL get_variable( pids_id, 'ls_forcing_south_u',                                     &
+                                nest_offl%u_s(0:1,:,1:1),                                          &
+                                MERGE( nzb+1, 1, bc_dirichlet_s),                                  &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_s),                       &
+                                MERGE( nest_offl%nzu, 0, bc_dirichlet_s),                          &
+                                MERGE( 2, 0, bc_dirichlet_s) )
+             CALL get_variable( pids_id, 'ls_forcing_south_v',                                     &
+                                nest_offl%v_s(0:1,:,1:1),                                          &
+                                MERGE( nzb+1, 1, bc_dirichlet_s),                                  &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_s),                       &
+                                MERGE( nest_offl%nzu, 0, bc_dirichlet_s),                          &
+                                MERGE( 2, 0, bc_dirichlet_s) )
+             CALL get_variable( pids_id, 'ls_forcing_south_w',                                     &
+                                nest_offl%w_s(0:1,:,1:1),                                          &
+                                MERGE( nzb+1, 1, bc_dirichlet_s),                                  &
+                                MERGE( nest_offl%tind+1, 1, bc_dirichlet_s),                       &
+                                MERGE( nest_offl%nzw, 0, bc_dirichlet_s),                          &
+                                MERGE( 2, 0, bc_dirichlet_s) )
+             IF ( .NOT. neutral )  THEN
+                CALL get_variable( pids_id, 'ls_forcing_south_pt',                                 &
+                                   nest_offl%pt_s(0:1,:,1:1),                                      &
+                                   MERGE( nzb+1, 1, bc_dirichlet_s),                               &
+                                   MERGE( nest_offl%tind+1, 1, bc_dirichlet_s),                    &
+                                   MERGE( nest_offl%nzu, 0, bc_dirichlet_s),                       &
+                                   MERGE( 2, 0, bc_dirichlet_s) ) 
+             ENDIF
+             IF ( humidity )  THEN
+                CALL get_variable( pids_id, 'ls_forcing_south_qv',                                 &
+                                   nest_offl%q_s(0:1,:,1:1),                                       &
+                                   MERGE( nzb+1, 1, bc_dirichlet_s),                               &
+                                   MERGE( nest_offl%tind+1, 1, bc_dirichlet_s),                    &
+                                   MERGE( nest_offl%nzu, 0, bc_dirichlet_s),                       &
+                                   MERGE( 2, 0, bc_dirichlet_s) )
+             ENDIF
+             IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+                DO  n = 1, UBOUND(nest_offl%var_names_chem_t, 1)
+                   IF ( check_existence( nest_offl%var_names,                                      &
+                                         nest_offl%var_names_chem_t(n) ) )  THEN
+                      CALL get_variable( pids_id, TRIM( nest_offl%var_names_chem_t(n) ),           &
+                                         nest_offl%chem_s(0:1,:,1:1,n),                            &
+                                         MERGE( nzb+1, 1, bc_dirichlet_s),                         &
+                                         MERGE( nest_offl%tind+1, 1, bc_dirichlet_s),              &
+                                         MERGE( nest_offl%nzu, 0, bc_dirichlet_s),                 &
+                                         MERGE( 2, 0, bc_dirichlet_s) )
+                      nest_offl%chem_from_file_s(n) = .TRUE.
+                   ENDIF
+                ENDDO
+             ENDIF
+          ENDIF
+!
+!--       Read top boundary data, which is actually only a scalar value in the LOD 1 case.
+          CALL get_variable( pids_id, 'ls_forcing_top_u',                                          &
+                             nest_offl%u_top(0:1,1,1),                                             & ! array to be read
+                             nest_offl%tind+1,                                                     & ! start index in time
+                             2 )                                                                     ! number of elements to be read
+          CALL get_variable( pids_id, 'ls_forcing_top_v',                                          &
+                             nest_offl%v_top(0:1,1,1),                                             &
+                             nest_offl%tind+1,                                                     &
+                             2 )
+          CALL get_variable( pids_id, 'ls_forcing_top_w',                                          &
+                             nest_offl%w_top(0:1,1,1),                                             &
+                             nest_offl%tind+1,                                                     &
+                             2 )
+          IF ( .NOT. neutral )  THEN
+             CALL get_variable( pids_id, 'ls_forcing_top_pt',                                      &
+                                nest_offl%pt_top(0:1,1,1),                                         &
+                                nest_offl%tind+1,                                                  &
+                                2 )
+          ENDIF
+          IF ( humidity )  THEN
+             CALL get_variable( pids_id, 'ls_forcing_top_qv',                                      &
+                                nest_offl%q_top(0:1,1,1),                                          &
+                                nest_offl%tind+1,                                                  &
+                                2 )
+          ENDIF
+          IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
+             DO  n = 1, UBOUND(nest_offl%var_names_chem_t, 1)
+                IF ( check_existence( nest_offl%var_names,                                         &
+                                      nest_offl%var_names_chem_t(n) ) )  THEN
+                   CALL get_variable( pids_id, TRIM( nest_offl%var_names_chem_t(n) ),              &
+                                      nest_offl%chem_top(0:1,1,1,n),                               &
+                                      nest_offl%tind+1,                                            &
+                                      2 )
+                   nest_offl%chem_from_file_t(n) = .TRUE.
+                ENDIF
+             ENDDO
+          ENDIF
+       ENDIF
+
 
 !
